> For the complete documentation index, see [llms.txt](https://docs.ox.security/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ox.security/api-documentation/api-reference/api--pipeline/queries/get-duration-trend.md).

# getDurationTrend

Retrieves trend data showing pipeline execution duration statistics over time.

### Examples

{% tabs %}
{% tab title="GraphQL" %}

```graphql
query GetDurationTrend($getPipelineSummaryInput: GetPipelineSummaryInput) {
  getDurationTrend(getPipelineSummaryInput: $getPipelineSummaryInput) {
    jobTriggeredAt
    avg
    min
    max
  }
}
```

#### Variables

This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.

```json
{
  "getPipelineSummaryInput": {
    "limit": 100,
    "offset": 0,
    "owners": ["example"],
    "tagIds": ["example"],
    "dateRange": {
      "from": 1749000000000,
      "to": 1749900000000
    },
    "filters": {
      "apps": ["example"],
      "result": ["example"],
      "jobTriggeredBy": ["example"],
      "sourceBranches": ["example"],
      "targetBranches": ["example"],
      "severities": ["example"],
      "eventTypes": ["example"],
      "cicdTypes": ["example"],
      "tags": ["example"],
      "jobId": ["example"],
      "scanCompletionStatus": ["example"],
      "pipelineScanType": ["example"],
      "pipelineArtifactName": ["example"],
      "pipelineArtifactTag": ["example"],
      "workflows": ["example"]
    },
    "openItems": ["digest"]
  }
}
```

{% endtab %}

{% tab title="cURL" %}

```shell
curl -X POST \
https://api.cloud.ox.security/api/apollo-gateway \
-H 'Content-Type: application/json' \
-H 'Authorization: YOUR_API_TOKEN' \
-d '{
 "query": "query GetDurationTrend($getPipelineSummaryInput: GetPipelineSummaryInput) { getDurationTrend(getPipelineSummaryInput: $getPipelineSummaryInput) { jobTriggeredAt avg min max } }",
 "variables": {
    "getPipelineSummaryInput": {
      "limit": 100,
      "offset": 0,
      "owners": ["example"],
      "tagIds": ["example"],
      "dateRange": {
        "from": 1749000000000,
        "to": 1749900000000
      },
      "filters": {
        "apps": ["example"],
        "result": ["example"],
        "jobTriggeredBy": ["example"],
        "sourceBranches": ["example"],
        "targetBranches": ["example"],
        "severities": ["example"],
        "eventTypes": ["example"],
        "cicdTypes": ["example"],
        "tags": ["example"],
        "jobId": ["example"],
        "scanCompletionStatus": ["example"],
        "pipelineScanType": ["example"],
        "pipelineArtifactName": ["example"],
        "pipelineArtifactTag": ["example"],
        "workflows": ["example"]
      },
      "openItems": ["digest"]
    }
  }
}'
```

{% endtab %}

{% tab title="Node.js" %}

```javascript
const query = 'query GetDurationTrend($getPipelineSummaryInput: GetPipelineSummaryInput) { getDurationTrend(getPipelineSummaryInput: $getPipelineSummaryInput) { jobTriggeredAt avg min max } }';

fetch("https://api.cloud.ox.security/api/apollo-gateway", {
  method: "POST",
  headers: {
    "Content-Type": "application/json",
    "Authorization": "YOUR_API_TOKEN"
  },
  body: JSON.stringify({
    query: query,
    // This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.
    variables: {
      getPipelineSummaryInput: {
        limit: 100,
        offset: 0,
        owners: ["example"],
        tagIds: ["example"],
        dateRange: {
          from: 1749000000000,
          to: 1749900000000
        },
        filters: {
          apps: ["example"],
          result: ["example"],
          jobTriggeredBy: ["example"],
          sourceBranches: ["example"],
          targetBranches: ["example"],
          severities: ["example"],
          eventTypes: ["example"],
          cicdTypes: ["example"],
          tags: ["example"],
          jobId: ["example"],
          scanCompletionStatus: ["example"],
          pipelineScanType: ["example"],
          pipelineArtifactName: ["example"],
          pipelineArtifactTag: ["example"],
          workflows: ["example"]
        },
        openItems: ["digest"]
      }
    }
  })
})
.then(response => response.json())
.then(result => console.log(JSON.stringify(result, null, 2)))
.catch(error => console.error('Error:', error));
```

{% endtab %}

{% tab title="Python" %}

```python
import requests

query = 'query GetDurationTrend($getPipelineSummaryInput: GetPipelineSummaryInput) { getDurationTrend(getPipelineSummaryInput: $getPipelineSummaryInput) { jobTriggeredAt avg min max } }'

response = requests.post(
  "https://api.cloud.ox.security/api/apollo-gateway",
  headers={
    "Content-Type": "application/json",
    "Authorization": "YOUR_API_TOKEN"
  },
  json={
    "query": query,
    # This is an example input showing all available input fields. Only fields marked as required in the schema are mandatory.
    "variables": {
      "getPipelineSummaryInput": {
        "limit": 100,
        "offset": 0,
        "owners": ["example"],
        "tagIds": ["example"],
        "dateRange": {
          "from": 1749000000000,
          "to": 1749900000000
        },
        "filters": {
          "apps": ["example"],
          "result": ["example"],
          "jobTriggeredBy": ["example"],
          "sourceBranches": ["example"],
          "targetBranches": ["example"],
          "severities": ["example"],
          "eventTypes": ["example"],
          "cicdTypes": ["example"],
          "tags": ["example"],
          "jobId": ["example"],
          "scanCompletionStatus": ["example"],
          "pipelineScanType": ["example"],
          "pipelineArtifactName": ["example"],
          "pipelineArtifactTag": ["example"],
          "workflows": ["example"]
        },
        "openItems": ["digest"]
      }
    }
  }
)

if response.status_code == 200:
    result = response.json()
    print(result)
else:
    print(f"Error: {response.status_code}")
    print(response.text)
```

{% endtab %}
{% endtabs %}

### Arguments

You can use the following argument(s) to customize your `getDurationTrend` query.

| Argument                                                                                                                                       | Description                                                                            | Supported fields                                                                                                                                                                                                                                                                                                                                                                     |
| ---------------------------------------------------------------------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ |
| getPipelineSummaryInput [`GetPipelineSummaryInput`](/api-documentation/api-reference/api--pipeline/types/inputs/get-pipeline-summary-input.md) | Parameters for filtering which pipeline data to include in the duration trend analysis | <p>limit <code>Int</code><br>offset <code>Int</code><br>owners <code>\[String]</code><br>tagIds <code>\[String]</code><br>dateRange <a href="/pages/ttgam4SI9scLHqwZwgrD"><code>DateRange</code></a><br>filters <a href="/pages/Pdtskend5lPDUnmLAJ3y"><code>PipelineSummaryFilters</code></a><br>openItems <a href="/pages/43jgm6P5kcKgBM8FmTho"><code>\[FilterTypes]</code></a></p> |

### Fields

Return type: [`[DurationTrendRes]`](/api-documentation/api-reference/api--pipeline/types/objects/duration-trend-res.md)

You can use the following field(s) to specify what information your `getDurationTrend` query will return. Please note that some fields may have their own subfields.

| Field                   | Description                                    | Supported fields |
| ----------------------- | ---------------------------------------------- | ---------------- |
| jobTriggeredAt `String` | Timestamp when the pipeline job was triggered  |                  |
| avg `Int`               | Average pipeline execution duration in seconds |                  |
| min `Int`               | Minimum pipeline execution duration in seconds |                  |
| max `Int`               | Maximum pipeline execution duration in seconds |                  |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.ox.security/api-documentation/api-reference/api--pipeline/queries/get-duration-trend.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
